#include <stdlib.h>
#include <windows.h>
#include <rapi.h>

#include "debug.h"
#include "dllversion.h"
char *GetAppPath()
{
    static char appname[1024];
    if (!GetModuleFileName(NULL, appname, 1024))
        return NULL;

    return appname;
}
void CheckITSDll()
{
    if (FAILED(CeRapiInit()))
    {
        error("CeRapiInit failed\n");
        exit(1);
    }

    DWORD outsize=0;
    HRESULT res= CeRapiInvoke(L"\\Windows\\ItsUtils.dll", L"ITGetVersion",
            0, NULL, &outsize, NULL, NULL, 0);
    if (res>10000 || res<ITSDLL_VERSION)
    {
        char *apppath= GetAppPath();
        char *dllpath= new char[strlen(apppath)];
        strcpy(dllpath, apppath);

        /* strip filename */
        char *lastbs=strrchr(dllpath, '\\');
        char *lastfs=strrchr(dllpath, '/');

        if (lastbs && (lastfs==NULL || lastbs>lastfs))
            lastbs[1]=0;
        else if (lastfs)
            lastfs[1]=0;

        char *pputexe= "pput.exe ";
        char *itsdll= "ItsUtils.dll";
        char *bswindows= " \\windows";

        char *dllcopycmd= new char[1+strlen(dllpath)*2+strlen(pputexe)+strlen(itsdll)+strlen(bswindows)];

        strcpy(dllcopycmd, dllpath);
        strcat(dllcopycmd, pputexe);
        strcat(dllcopycmd, dllpath);
        strcat(dllcopycmd, itsdll);
        strcat(dllcopycmd, bswindows);

        system(dllcopycmd);
    }
}
