@echo off
mkdir build 2>nul

set ppcsdk=G:\Windows CE Tools\wce300\Pocket PC 2002
set cesdk=G:\Program Files\Microsoft eMbedded Tools\evc\WCE300
set stlevc=C:\local\stl_evc
set pbsrc=G:\archive\software\WinCE Platform Builder\DISK2

set cc=%cesdk%\bin\clarm.exe
rem !!! do not name this variable 'link', it confuses the linker.
set ld=%cesdk%\bin\link.exe
set include=%ppcsdk%\include
set lib=%ppcsdk%\lib\arm


set pbincs=/I "%pbsrc%\PRIVATE\WINCEOS\COREOS\NK\INC" /I "%pbsrc%\PUBLIC\COMMON\OAK\INC" /I "%pbsrc%\PUBLIC\COMMON\SDK\INC"

rem /Zi /Od /Fd"build/" for debugging
rem /O2      for release
set cflags=/nologo /W3 /O2 /MC /c /Fo"build/" /I %stlevc% %pbincs%
set targetdefs=/D "ARM" /D "_ARM_"
set platformdefs=/D _WIN32_WCE=300 /D "WIN32_PLATFORM_PSPC=310" /D UNDER_CE=300 /D "UNICODE" /D "_UNICODE"
set cdefs=/D "DEBUG" %targetdefs% %platformdefs%
set dlldefs=/D "_USRDLL"

"%cc%" %cflags% %cdefs% %dlldefs% /D "ITSUTILS_EXPORTS" ItsUtils.cpp
if errorlevel 1 goto end
"%cc%" %cflags% %cdefs% %dlldefs% /D "SPRAPIUTILS_EXPORTS" sprapiutils.cpp
if errorlevel 1 goto end

set lddllflags=/entry:"_DllMainCRTStartup" /dll 
set ldexeflags=/entry:"WinMainCRTStartup"
set ldplatformflags=/subsystem:windowsce,3.00 /align:"4096" 
set ldtargetflags=/MACHINE:ARM 
set ldflags=/nologo /base:"0x00100000" /stack:0x10000,0x1000 %ldtargetflags% %ldplatformflags%

set nodeflib=/nodefaultlib:libc.lib /nodefaultlib:libcd.lib /nodefaultlib:libcmt.lib /nodefaultlib:libcmtd.lib /nodefaultlib:msvcrt.lib /nodefaultlib:msvcrtd.lib /nodefaultlib:oldnames.lib

set extralibs=toolhelp.lib 

rem /pdb:"build/itsutils.pdb" /debug  

"%ld%" %ldflags% %extralibs% %nodeflib% %lddllflags% /out:"build/itsutils.dll" /implib:"build/itsutils.lib" "build\itsutils.obj"
if errorlevel 1 goto end
"%ld%" %ldflags% %extralibs% %nodeflib% %lddllflags% /out:"build/sprapiutils.dll" /implib:"build/sprapiutils.lib" "build\sprapiutils.obj"
if errorlevel 1 goto end

:end

